import keggapi.*;
import java.util.ArrayList;
import java.io.*;
import java.rmi.*;
import java.awt.*; 
import java.awt.event.*;   

public class EsFinale extends Canvas {
        
    private static String org_id;
    private static KEGGPortType serv;
    private static int[] enz = new int[3];
    private static int genomaLength;
    
    public void paint(Graphics g){
       g.drawString("ec:2.7.1.6",100,40);
       g.drawLine(100, 50, 450, 50);
       g.drawOval(100+EsFinale.proporzione(enz[0]),48,4,4);
             
       g.drawString("ec:2.7.7.10",100,90);
       g.drawLine(100, 100, 450, 100);
       g.drawOval(100+EsFinale.proporzione(enz[1]),98,4,4);
             
       g.drawString("ec:5.4.2.2",100,140);
       g.drawLine(100, 150, 450, 150);    
       g.drawOval(100+EsFinale.proporzione(enz[2]),148,4,4);        
    }
    
    public static void main(String[] args) throws Exception {
        KEGGLocator  locator = new KEGGLocator();
        serv = locator.getKEGGPort();
        Definition[] def = serv.list_organisms();
        String[] result;

        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        System.out.println("Seleziona l'organismo");
        ArrayList lista = new ArrayList();
        int count=0;
        int scelta=0;
        for (int i = 0; i < def.length; i++) {
            if((def[i].getDefinition()).indexOf(args[0])!=-1){
                lista.add(def[i].getEntry_id());
                System.out.println(count+")"+def[i].getDefinition());
                count++;
            }        
        }
        scelta = Integer.parseInt(in.readLine());
        org_id = (String)lista.get(scelta);        

        try {
            enz[0] = getEnzymePosition("ec:2.7.1.6");
            enz[1] = getEnzymePosition("ec:2.7.7.10");
            enz[2] = getEnzymePosition("ec:5.4.2.2");
        
            genomaLength = getGenomaLength();
                
            Canvas frame = new EsFinale();
            Frame finestra = new Frame();
            finestra.add(frame);
        
            finestra.setSize(650, 190);
            finestra.setResizable(false);
            finestra.setVisible(true);
        }
        catch(Exception ex) {
            System.out.println("Ops... Qualcosa e' andato storto...");
            System.exit(1);
        }
    }


    public static int getEnzymePosition(String enzyme) throws RemoteException{
        String[] result = serv.get_genes_by_enzyme(enzyme,org_id);
        String bget = serv.bget(result[0]);
        int begin = bget.indexOf("POSITION");
        int end = bget.indexOf(".",begin);
        String value = bget.substring(begin+12,end);
        return Integer.parseInt(value);
    }
    
    public static int getGenomaLength() throws RemoteException{
        String bget = serv.bget("gn:"+org_id);
                System.out.println("\n" + bget);
        int begin = bget.indexOf("LENGTH");
        int end = bget.indexOf("\n",begin);
        String value = bget.substring(begin+10,end);
        return Integer.parseInt(value);
    }
        
    public static int proporzione(int enz) {
        return ((enz*500)/genomaLength);
    }
}

